define(
	[
		"epi-cms/widget/_HasChildDialogMixin",
		"dojo/_base/declare",
		"dijit/_Widget",
		"dijit/_TemplatedMixin",
		"dojo/html"
	], 
	function(
		_HasChildDialogMixin,
		declare,
		_Widget,
		_TemplatedMixin,
		html
	) {
		return declare([_Widget, _TemplatedMixin, _HasChildDialogMixin], 
		{
			// templateString: [protected] String
			// A string that represents the default widget template.
			templateString: '<div class="dijitInline"><div style="cursor:pointer;" data-dojo-attach-point="bbild" title="Klicka här för att ange film">Klicka här för att ange film</div><div style=\"cursor:pointer\" data-dojo-attach-point=\"bortbild\"></div></div>',
			
			_setValueAttr: function (value) 
			{
				// summary : Sets the value of the widget to "value" and updates the value displayed in the textbox.
				// tags    : private
				//console.log('setvalue: ', value);
				this._set('value', value);
				if(value && value.mediaID) {
				  var _this = this;
				  setTimeout(function() {
				    html.set(_this.bbild, '<img src="https://m.mediaflow.com/poster/' + value.mediaID + '?w=192&h=108" />');
					html.set(_this.bortbild, 'Ta bort aktuell film');
				  }, 5);
			    } else {
				  html.set(this.bbild, 'Klicka här för att ange film');
				  html.set(this.bortbild, '');
				}
			},
						
			postCreate: function () 
			{
				// summary : Connects keyboard events of the email textbox to update the value of the editor.
				// tags    : protected
				this.connect(this.bbild, 'onclick', this._onClicka);
				this.connect(this.bortbild, 'onclick', this._bortclick);
			},

			_onClicka: function (event) 
			{
			    if(this.readOnly) {
					alert('Du har inte behörighet att ändra film');
					return;
			    }
				this._showChildDialog();
			},
			
			_bortclick: function (event) 
			{
			    if(this.readOnly) {
					alert('Du har inte behörighet att ta bort filmen');
					return;
			    }
				if(window.confirm('Är du säker på att du vill ta bort aktuell film?')) {
					var v = {autoPlay: false, mediaID: '', startAt: 0, embedType: 'javascript'};
					this._set('value', v);
					this.onChange(v);
					html.set(this.bbild, 'Klicka här för att ange film');
					html.set(this.bortbild, '');
				}
			},
			
			_clickDone: function (o) 
			{
				if(!o.mediaId) {
					alert('Ett fel inträffade när filmen skulle sparas (mediaId == null)!');
					this._dialog.hide();
					return;
				}
				var v = {autoPlay: o.autoPlay, mediaID: o.mediaId, startAt: o.startTime, embedType: o.embedMethod, selectedID: o.id, selectedFolder: o.selectedFolder};
				this._set('value', v);
				this.onChange(v);
				html.set(this.bbild, '<img src="https://m.mediaflow.com/poster/' + v.mediaID + '?w=192&h=108" title="Klicka för att ange film" />');
				html.set(this.bortbild, 'Ta bort aktuell film');
				this._dialog.hide();
			},
			
			_showChildDialog: function () 
			{
				var w,h,dialogurl,mediaID,autoPlay,startAt,embedType,selectedID,selectedFolder;
				if(window.innerHeight) {
				  w = window.innerWidth;
				  h = window.innerHeight;
				} else {
				  h = document.compatMode!=='BackCompat'? document.documentElement.clientHeight : document.body.clientHeight;
				  w = document.compatMode!=='BackCompat'? document.documentElement.clientWidth : document.body.clientWidth;
				}
				mediaID = '';
				if(this.value && this.value.mediaID)
					mediaID = this.value.mediaID;
				autoPlay = '0';
				if(this.value && this.value.autoPlay===true)
					autoPlay = '1';
				startAt = '0';
				if(this.value && this.value.startAt>0)
					startAt = this.value.startAt;
				embedType = '0';
				if(this.value && this.value.embedType=='iframe')
					embedType = '1';
				selectedID = '0';
				if(this.value && this.value.selectedID>0)
					selectedID = this.value.selectedID;
				selectedFolder = '0';
				if(this.value && this.value.selectedFolder>0)
					selectedFolder = this.value.selectedFolder;
				dialogurl = '../Mediaflow.Video.Plugin/Scripts/dialogcontents.aspx?id=' + this.id + '&mid=' + mediaID + '&ap=' + autoPlay + '&sa=' + startAt + '&et=' + embedType + '&si=' + selectedID + '&sf=' + selectedFolder;
				this._dialog = dijit.Dialog(
				  {
					title: 'Infoga video från Mediaflow',
					content: '<iframe width="' + (w-200) + '" height="' + (h-200) + '" frameborder="0" style="background-color:#000;" src="' + dialogurl + '"></iframe>'
				  });
				this.connect(this._dialog, 'onHide', this._onHide);
				this.isShowingChildDialog = true;
				this._dialog.containerNode.style.padding = '0';
				this._dialog.show();
			},

			_onHide: function () 
			{
				this.isShowingChildDialog = false;
			}			
		})
	}
);
