(function (tinymce,$) {
    tinymce.create('tinymce.plugins.mediaflowvideo', {
        init: function (ed, url) {
            // Register commands
            ed.addCommand('mceMediaflowVideo', function () {
            var w,h;
            var cPageId = '0';
            var cLanguage = '';

			var contextService;
			try {
				contextService = epi.dependency.resolve("epi.shell.ContextService");
			}
			catch(err) {}						
            if(contextService) {
              var currentContext = contextService.currentContext;
              if(currentContext && currentContext.id) {
                var res = currentContext.id.split("_");
                cPageId = res[0];
                if(currentContext.language)
                  cLanguage = currentContext.language;
              }
            } else {
              if(this.settings && this.settings.epi_page_context && this.settings.epi_page_context.id.indexOf('_')>=0)
                cPageId = this.settings.epi_page_context.id.split('_')[0];
              if(this.settings && this.settings.epi_page_context && this.settings.epi_page_context.epslanguage)
                cLanguage = this.settings.epi_page_context.epslanguage;
			}
            w = $(window).width();
            h = $(window).height();            
            ed.windowManager.open({
              title: 'Infoga video från Mediaflow',
              file: url + '/dialogcontentsMCE.aspx?pg=' + cPageId + '&lang=' + cLanguage,
              width: w-70,
              height: h-70,
              inline: 1
            }, {
              plugin_url: url
            });
            });

            // Register buttons
            ed.addButton('btnMediaflowVideo',
                {
                    title: 'Infoga video från Mediaflow', 
                    cmd: 'mceMediaflowVideo',
                    image: '/ClientResources/Scripts/mfvideo/Mediaflow-epi-insert_video.png'
                });
        },

        getInfo: function () {
            return {
                longname: 'Mediaflow',
                author: 'Mediaflow Europe AB',
                authorurl: 'http://www.mediaflow.com',
                infourl: 'http://www.mediaflow.com',
                version: tinymce.majorVersion + "." + tinymce.minorVersion
            };
        }
    });

    // Register plugin
    tinymce.PluginManager.add('mediaflowvideo', tinymce.plugins.mediaflowvideo);
})(tinymce,epiJQuery);